
/*
 * Generated data (by mkcproc.pl)
 */
#line 1 "bsecategories.proc"
// Licensed GNU LGPL v2.1 or later: http://www.gnu.org/licenses/lgpl.html
#include <bse/bsecategories.hh>
#include <bse/bseprocedure.hh>
#include <bse/bseplugin.hh>
#include "bsecxxplugin.hh"
#include "bsebuiltin_externs.cc"


#line 11 "bsecategories.proc"


/* --- bse-categories-match-typed --- */
static void
bse_categories_match_typed_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 13 "bsecategories.proc"
 {
#line 15 "bsecategories.proc"
  *(in_pspecs++) = sfi_pspec_string ("pattern", "Pattern", "Pattern to match category, supports '*' and '?' wildcards.",
			    "*", SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_string ("type", "Type", "Base type for categories to conform to.",
			    NULL, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_boxed ("categories", "Categories", NULL, BSE_TYPE_CATEGORY_SEQ, SFI_PARAM_STANDARD);
}
#line 21 "bsecategories.proc"
 }
static Bse::Error
#line 21 "bsecategories.proc"
bse_categories_match_typed_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 24 "bsecategories.proc"
{
#line 25 "bsecategories.proc"
  
  const char *pattern   = sfi_value_get_string (in_values++);
  const char *type_name = sfi_value_get_string (in_values++);
  GType  type     = type_name ? g_type_from_name (type_name) : 0;
  BseCategorySeq *cseq = NULL;

#line 31 "bsecategories.proc"
  
  if (!pattern)
    return Bse::Error::PROC_PARAM_INVAL;

  if (type)
    cseq = bse_categories_match_typed (pattern, type);
  if (!cseq)
    cseq = bse_category_seq_new ();

#line 40 "bsecategories.proc"
  
  bse_value_take_boxed (out_values++, cseq);

  return Bse::Error::NONE;
}

/* --- bse-categories-match --- */
static void
bse_categories_match_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 46 "bsecategories.proc"
 {
#line 48 "bsecategories.proc"
  *(in_pspecs++) = sfi_pspec_string ("pattern", "Pattern", "Pattern to match category, supports '*' and '?' wildcards.",
			    "*", SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_boxed ("categories", "Categories", NULL, BSE_TYPE_CATEGORY_SEQ, SFI_PARAM_STANDARD);
}
#line 52 "bsecategories.proc"
 }
static Bse::Error
#line 52 "bsecategories.proc"
bse_categories_match_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 55 "bsecategories.proc"
{
#line 56 "bsecategories.proc"
  
  const char *pattern   = sfi_value_get_string (in_values++);
  BseCategorySeq *cseq = NULL;

#line 60 "bsecategories.proc"
  
  if (!pattern)
    return Bse::Error::PROC_PARAM_INVAL;

  cseq = bse_categories_match_typed (pattern, 0);
  if (!cseq)
    cseq = bse_category_seq_new ();

#line 68 "bsecategories.proc"
  
  bse_value_take_boxed (out_values++, cseq);

  return Bse::Error::NONE;
}

/* --- Export to BSE --- */
static void
__enode_bse_categories_match_typed__fill_strings (BseExportStrings *es)
{
  es->blurb = "List BSE categories according to a pattern and type match.";
  es->file = "/opt/src/beast/bse/bsecategories.proc";
  es->line = 14;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_bse_categories_match_typed = {
  { NULL, BSE_EXPORT_NODE_PROC,
    "bse-categories-match-typed", 
    NULL,
    "/Proc/Categories/Match Typed",
    NULL,
    __enode_bse_categories_match_typed__fill_strings,
  },
  0, bse_categories_match_typed_setup, bse_categories_match_typed_exec, 
};
static void
__enode_bse_categories_match__fill_strings (BseExportStrings *es)
{
  es->blurb = "List BSE categories according to a pattern match.";
  es->file = "/opt/src/beast/bse/bsecategories.proc";
  es->line = 47;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_bse_categories_match = {
  { (BseExportNode*) &__enode_bse_categories_match_typed, BSE_EXPORT_NODE_PROC,
    "bse-categories-match", 
    NULL,
    "/Proc/Categories/Match",
    NULL,
    __enode_bse_categories_match__fill_strings,
  },
  0, bse_categories_match_setup, bse_categories_match_exec, 
};
extern "C" BseExportNode* bse__builtin_init_bsecategories_genprc_cc (void)
{
  return (BseExportNode*) &__enode_bse_categories_match;
}

/*
 * Generated data ends here
 */
