
/*
 * Generated data (by mkcproc.pl)
 */
#line 1 "bseeditablesample.proc"
// Licensed GNU LGPL v2.1 or later: http://www.gnu.org/licenses/lgpl.html
#include <bse/bseplugin.hh>
#include <bse/bseprocedure.hh>
#include <bse/bseeditablesample.hh>
#include <bse/gsldatahandle.hh>
#include "bsecxxplugin.hh"
#include "bsebuiltin_externs.cc"


/* --- open --- */
static void
open_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 12 "bseeditablesample.proc"
 {
#line 14 "bseeditablesample.proc"
  *(in_pspecs++) = bse_param_spec_object ("esample", "Editable Sample", NULL,
				 BSE_TYPE_EDITABLE_SAMPLE, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_genum ("error", "Error", NULL,
				BSE_TYPE_ERROR_TYPE, Bse::Error::NONE,
				SFI_PARAM_STANDARD);
#line 19 "bseeditablesample.proc"
}  }
static Bse::Error
#line 19 "bseeditablesample.proc"
open_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 22 "bseeditablesample.proc"
{
#line 23 "bseeditablesample.proc"
  
  BseEditableSample *esample = (BseEditableSample*) bse_value_get_object (in_values++);
  Bse::Error error;

#line 27 "bseeditablesample.proc"
  
  if (!BSE_IS_EDITABLE_SAMPLE (esample))
    return Bse::Error::PROC_PARAM_INVAL;

#line 31 "bseeditablesample.proc"
  
  if (!esample->wchunk)
    error = Bse::Error::WAVE_NOT_FOUND;
  else if (esample->open_count)
    {
      esample->open_count++;
      error = Bse::Error::NONE;
    }
  else
    {
      error = gsl_wave_chunk_open (esample->wchunk);
      if (error == 0)
	esample->open_count++;
    }

#line 46 "bseeditablesample.proc"
  
  g_value_set_enum (out_values++, int (error));

  return Bse::Error::NONE;
}

/* --- close --- */
static void
close_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 52 "bseeditablesample.proc"
 {
#line 54 "bseeditablesample.proc"
  *(in_pspecs++) = bse_param_spec_object ("esample", "Editable Sample", NULL,
				 BSE_TYPE_EDITABLE_SAMPLE, SFI_PARAM_STANDARD);
#line 56 "bseeditablesample.proc"
}  }
static Bse::Error
#line 56 "bseeditablesample.proc"
close_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 59 "bseeditablesample.proc"
{
#line 60 "bseeditablesample.proc"
  
  BseEditableSample *esample = (BseEditableSample*) bse_value_get_object (in_values++);

#line 63 "bseeditablesample.proc"
  
  if (!BSE_IS_EDITABLE_SAMPLE (esample) || !esample->wchunk || !esample->open_count)
    return Bse::Error::PROC_PARAM_INVAL;

#line 67 "bseeditablesample.proc"
  
  esample->open_count--;
  if (!esample->open_count)
    gsl_wave_chunk_close (esample->wchunk);

  return Bse::Error::NONE;
}

/* --- get-length --- */
static void
get_length_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 75 "bseeditablesample.proc"
 {
#line 77 "bseeditablesample.proc"
  *(in_pspecs++) = bse_param_spec_object ("esample", "Editable Sample", NULL,
				 BSE_TYPE_EDITABLE_SAMPLE, SFI_PARAM_STANDARD);
  *(out_pspecs++) = sfi_pspec_int ("length", NULL, "Number of values",
			 1, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
#line 81 "bseeditablesample.proc"
}  }
static Bse::Error
#line 81 "bseeditablesample.proc"
get_length_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 84 "bseeditablesample.proc"
{
#line 85 "bseeditablesample.proc"
  
  BseEditableSample *esample = (BseEditableSample*) bse_value_get_object (in_values++);
  GslDataCache *dcache = NULL;

#line 89 "bseeditablesample.proc"
  
  if (!BSE_IS_EDITABLE_SAMPLE (esample))
    return Bse::Error::PROC_PARAM_INVAL;

#line 93 "bseeditablesample.proc"
  
  if (BSE_EDITABLE_SAMPLE_OPENED (esample) && esample->wchunk)
    dcache = esample->wchunk->dcache;
  sfi_value_set_int (out_values++, dcache ? gsl_data_handle_length (dcache->dhandle) : 0);

  return Bse::Error::NONE;
}

/* --- get-n-channels --- */
static void
get_n_channels_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 101 "bseeditablesample.proc"
 {
#line 103 "bseeditablesample.proc"
  *(in_pspecs++) = bse_param_spec_object ("esample", "Editable Sample", NULL,
				 BSE_TYPE_EDITABLE_SAMPLE, SFI_PARAM_STANDARD);
  *(out_pspecs++) = sfi_pspec_int ("n-channels", NULL, "Number of channels",
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
#line 107 "bseeditablesample.proc"
}  }
static Bse::Error
#line 107 "bseeditablesample.proc"
get_n_channels_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 110 "bseeditablesample.proc"
{
#line 111 "bseeditablesample.proc"
  
  BseEditableSample *esample = (BseEditableSample*) bse_value_get_object (in_values++);

#line 114 "bseeditablesample.proc"
  
  if (!BSE_IS_EDITABLE_SAMPLE (esample))
    return Bse::Error::PROC_PARAM_INVAL;

#line 118 "bseeditablesample.proc"
  
  sfi_value_set_int (out_values++, esample->wchunk ? esample->wchunk->n_channels : 1);

  return Bse::Error::NONE;
}

/* --- get-osc-freq --- */
static void
get_osc_freq_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 124 "bseeditablesample.proc"
 {
#line 126 "bseeditablesample.proc"
  *(in_pspecs++) = bse_param_spec_object ("esample", "Editable Sample", NULL,
				 BSE_TYPE_EDITABLE_SAMPLE, SFI_PARAM_STANDARD);
  *(out_pspecs++) = bse_param_spec_freq_simple ("osc-freq", NULL, "Oscillator Frequency",
				      SFI_PARAM_STANDARD);
#line 130 "bseeditablesample.proc"
}  }
static Bse::Error
#line 130 "bseeditablesample.proc"
get_osc_freq_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 133 "bseeditablesample.proc"
{
#line 134 "bseeditablesample.proc"
  
  BseEditableSample *esample = (BseEditableSample*) bse_value_get_object (in_values++);

#line 137 "bseeditablesample.proc"
  
  if (!BSE_IS_EDITABLE_SAMPLE (esample))
    return Bse::Error::PROC_PARAM_INVAL;

#line 141 "bseeditablesample.proc"
  
  sfi_value_set_real (out_values++, esample->wchunk ? esample->wchunk->osc_freq : BSE_KAMMER_FREQUENCY);

  return Bse::Error::NONE;
}

/* --- collect-stats --- */
static void
collect_stats_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 147 "bseeditablesample.proc"
 {
#line 149 "bseeditablesample.proc"
  *(in_pspecs++) = bse_param_spec_object ("esample", "Editable Sample", NULL,
				 BSE_TYPE_EDITABLE_SAMPLE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("voffset", NULL, "Offset of first stat block",
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_real ("offset_scale", NULL, "Factor to scale voffset increments with",
			  0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("block_size", NULL, "Block size to compute stat pairs from",
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("stepping", NULL, "Stepping within a stat block",
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("max_pairs", NULL, "Maximum number of (min, max) pairs to collect",
			 1, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_boxed ("sample_block", NULL, "Block of samples", BSE_TYPE_FLOAT_SEQ, SFI_PARAM_STANDARD);
#line 162 "bseeditablesample.proc"
}  }
static Bse::Error
#line 162 "bseeditablesample.proc"
collect_stats_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 165 "bseeditablesample.proc"
{
#line 166 "bseeditablesample.proc"
  
  BseEditableSample *esample    = (BseEditableSample*) bse_value_get_object (in_values++);
  guint              voffset    = sfi_value_get_int (in_values++);
  double             offs_scale = g_value_get_double (in_values++);
  guint              block_size = sfi_value_get_int (in_values++);
  guint              stepping   = sfi_value_get_int (in_values++);
  guint              max_pairs  = sfi_value_get_int (in_values++);
  GslDataCache *dcache = NULL;
  BseFloatSeq *fseq;
#line 175 "bseeditablesample.proc"
  
  if (!BSE_IS_EDITABLE_SAMPLE (esample) || stepping < 1)
    return Bse::Error::PROC_PARAM_INVAL;
  if (BSE_EDITABLE_SAMPLE_OPENED (esample) && esample->wchunk)
    dcache = esample->wchunk->dcache;
  if (!dcache || voffset + block_size > gsl_data_handle_length (dcache->dhandle))
    {
      fseq = bse_float_seq_new ();
      bse_float_seq_resize (fseq, max_pairs * 2);
    }
  else
    {
      GslDataCacheNode *dnode = gsl_data_cache_ref_node (dcache, voffset, GSL_DATA_CACHE_DEMAND_LOAD);
      guint j, dnode_length = dcache->node_size;
      fseq = bse_float_seq_new();
      bse_float_seq_resize (fseq, max_pairs * 2);
      for (j = 0; j < max_pairs; j++)
	{
	  guint i, cur_offset = j * offs_scale;
	  float min = +1, max = -1;
#line 195 "bseeditablesample.proc"
	  
	  cur_offset /= stepping;
	  cur_offset = voffset + cur_offset * stepping;
#line 198 "bseeditablesample.proc"
	  
	  for (i = cur_offset; i < cur_offset + block_size; i += stepping)
	    {
	      guint pos;
	      if (i < dnode->offset || i >= dnode->offset + dnode_length)
		{
		  gsl_data_cache_unref_node (dcache, dnode);
#line 205 "bseeditablesample.proc"
		  
		  dnode = gsl_data_cache_ref_node (dcache, i, j == 0 ? GSL_DATA_CACHE_DEMAND_LOAD : GSL_DATA_CACHE_PEEK);
		  if (!dnode)
		    goto break_loops;
		}
	      pos = i - dnode->offset;
	      min = MIN (min, dnode->data[pos]);
	      max = MAX (max, dnode->data[pos]);
	    }
	  fseq->values[j * 2] = min;
	  fseq->values[j * 2 + 1] = max;
	}
      gsl_data_cache_unref_node (dcache, dnode);
    break_loops:
      bse_float_seq_resize (fseq, j * 2);
    }
#line 221 "bseeditablesample.proc"
  
  g_value_take_boxed (out_values++, fseq);
  return Bse::Error::NONE;
}

/* --- Export to BSE --- */
static void
__enode_open__fill_strings (BseExportStrings *es)
{
  es->blurb = ("Open the sample for reading.");
  es->file = "/opt/src/beast/bse/bseeditablesample.proc";
  es->line = 13;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_open = {
  { NULL, BSE_EXPORT_NODE_PROC,
    "BseEditableSample+open", 
    NULL,
    "/Methods/BseEditableSample/General/Open",
    NULL,
    __enode_open__fill_strings,
  },
  0, open_setup, open_exec, 
};
static void
__enode_close__fill_strings (BseExportStrings *es)
{
  es->blurb = ("Close an opened sample.");
  es->file = "/opt/src/beast/bse/bseeditablesample.proc";
  es->line = 53;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_close = {
  { (BseExportNode*) &__enode_open, BSE_EXPORT_NODE_PROC,
    "BseEditableSample+close", 
    NULL,
    "/Methods/BseEditableSample/General/Close",
    NULL,
    __enode_close__fill_strings,
  },
  0, close_setup, close_exec, 
};
static void
__enode_get_length__fill_strings (BseExportStrings *es)
{
  es->blurb = ("Return the number of values in the sample.");
  es->file = "/opt/src/beast/bse/bseeditablesample.proc";
  es->line = 76;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_get_length = {
  { (BseExportNode*) &__enode_close, BSE_EXPORT_NODE_PROC,
    "BseEditableSample+get-length", 
    NULL,
    "/Methods/BseEditableSample/General/Get Length",
    NULL,
    __enode_get_length__fill_strings,
  },
  0, get_length_setup, get_length_exec, 
};
static void
__enode_get_n_channels__fill_strings (BseExportStrings *es)
{
  es->blurb = ("Return the number of channels in the sample.");
  es->file = "/opt/src/beast/bse/bseeditablesample.proc";
  es->line = 102;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_get_n_channels = {
  { (BseExportNode*) &__enode_get_length, BSE_EXPORT_NODE_PROC,
    "BseEditableSample+get-n-channels", 
    NULL,
    "/Methods/BseEditableSample/General/Get N Channels",
    NULL,
    __enode_get_n_channels__fill_strings,
  },
  0, get_n_channels_setup, get_n_channels_exec, 
};
static void
__enode_get_osc_freq__fill_strings (BseExportStrings *es)
{
  es->blurb = ("Return the oscillator frequency for the sample.");
  es->file = "/opt/src/beast/bse/bseeditablesample.proc";
  es->line = 125;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_get_osc_freq = {
  { (BseExportNode*) &__enode_get_n_channels, BSE_EXPORT_NODE_PROC,
    "BseEditableSample+get-osc-freq", 
    NULL,
    "/Methods/BseEditableSample/General/Get Osc Freq",
    NULL,
    __enode_get_osc_freq__fill_strings,
  },
  0, get_osc_freq_setup, get_osc_freq_exec, 
};
static void
__enode_collect_stats__fill_strings (BseExportStrings *es)
{
  es->blurb = ("Collect statistics from sample blocks as (minimum, maximum) pairs.");
  es->file = "/opt/src/beast/bse/bseeditablesample.proc";
  es->line = 148;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_collect_stats = {
  { (BseExportNode*) &__enode_get_osc_freq, BSE_EXPORT_NODE_PROC,
    "BseEditableSample+collect-stats", 
    NULL,
    "/Methods/BseEditableSample/General/Collect Stats",
    NULL,
    __enode_collect_stats__fill_strings,
  },
  0, collect_stats_setup, collect_stats_exec, 
};
extern "C" BseExportNode* bse__builtin_init_bseeditablesample_genprc_cc (void)
{
  return (BseExportNode*) &__enode_collect_stats;
}

/*
 * Generated data ends here
 */
